<?php

namespace app\base;

use Yii;
use yii\helpers\Url;
use yii\helpers\Html;
use yii\helpers\ArrayHelper;
use yii\grid\GridView;
use yii\data\ArrayDataProvider;

use kartik\widgets\DepDrop;

use app\base\Converter;
use rmrevin\yii\fontawesome\FA;

use app\models\Mainmenu;
use app\models\Submenu;
use app\models\Menuprivileges;
use app\models\Users;

use app\models\State;
use app\models\District;
use app\models\Staff;
use app\models\Artcentre;
use app\models\Vll;
use app\models\Boxidref;
use app\models\Userrole;
use app\models\Stafflocationmapping;

class Common
{
   
    public static function getMainmenus()
    {
        $Mainmenus = ArrayHelper::map(Mainmenu::find()->where(["status" => 1])->orderBy(["min_mnu_desc" => SORT_ASC])->all(), 'min_mnu_id', 'min_mnu_desc');
        return $Mainmenus;
    }

    public static function getSubmenus()
    {
        $Submenus = ArrayHelper::map(Submenu::find()->orderBy(["sub_mnu_desc" => SORT_ASC])->all(), 'sub_mnu_id', 'sub_mnu_desc');
        return $Submenus;
    }

    public static function getUsersAll()
    {
        $Users = ArrayHelper::map(Users::find()->orderBy(["users_name" => SORT_ASC])->all(), 'usr_id',  function($model) {  return $model['users_name'].' - [ '.$model['full_name'].' ]';          
        });	 	
        return $Users;
    }
	
	   public static function getUsers()
    {
		
	    $Model = Menuprivileges::find()->all();	
        $Users = ArrayHelper::map(Users::find()->where(["NOT IN", "usr_id", ArrayHelper::getColumn($Model, "mnu_acs_usr_id_fk")])->orderBy(["users_name" => SORT_ASC])->all(), 'usr_id',  function($model) {  return $model['users_name'].' - [ '.$model['full_name'].' ]';          
        });	 	
        return $Users;
    }
   
  
    public static function getMenuname()
    {
        $Submenu = Submenu::find()->where(["sub_mnu_name" => Yii::$app->controller->id.'/'.Yii::$app->controller->action->id])->one();
        if($Submenu !== null)
            return $Submenu->sub_mnu_desc;
        else {
            // $Submenu = Submenu::find()->where(["LIKE", "sub_mnu_name", Yii::$app->controller->id])->one();
            $Submenu = Submenu::find()->where("sub_mnu_name like '".Yii::$app->controller->id."%'")->one();
            if($Submenu !== null)
                return $Submenu->sub_mnu_desc;
        }
    }

    public static function getPrivileges($option)
    {
        $Menuprivileges = Menuprivileges::find()->joinWith('submenus s')->where(["s.sub_mnu_name" => Yii::$app->controller->id])->andWhere(["mnu_acs_usr_id_fk" => Yii::$app->user->getId()])->one();
        $Menuprivileges = Menuprivileges::find()->joinWith('submenus s')->where(["LIKE", "s.sub_mnu_name", Yii::$app->controller->id])->andWhere(["mnu_acs_usr_id_fk" => Yii::$app->user->getId()])->one();
        if($Menuprivileges !== null) {
            if($option == 'Create')
                return $Menuprivileges->mnu_acs_add;
            elseif($option == 'Update')
                return $Menuprivileges->mnu_acs_edit;
            elseif($option == 'Delete')
                return $Menuprivileges->mnu_acs_delete;
        } else
            return true;
    }
    
  
    public static function generateLoc($form, $model, $template, $ctrlid)
    {
    	$storevalue = $dispvalue = "";
		   
        $storevalue = $model->$ctrlid;				
		$dispvalue ="";	                          
      		
            $template['template'] = preg_replace_callback("/{\\w+}/", function ($matches) use ($dispvalue) {
                switch ($matches[0]) {
                    case '{error}':
                          return $dispvalue;
                    default:
                        return $matches[0];
                }
            }, $template['template']);
            return $form->field($model, $ctrlid, $template)->hiddenInput(['value' => $storevalue]);
        
    }
   
   public static function convertTemplate($template, $type, $value)
    {
        $matches = preg_split('/(<[^>]*[\/div]>)/i', $template['template'], -1, PREG_SPLIT_NO_EMPTY | PREG_SPLIT_DELIM_CAPTURE);
        if($type == "prepand") {
            $len = count($matches);
            $matches[] = $matches[$len-1];
            $matches[$len-1] = $matches[$len-2];
            $matches[$len-2] = '<div class="col-md-3 text-prepand">'.$value.'</div>';
        } else {
            $matches[] = '<div class="col-md-3 text-postpand">'.$value.'</div>';
        }
        $template['template'] = implode("", $matches);
        return $template;
    }
	
	
	public static function getUsername($uid)
    {
        $Users = Users::find()->where(["usr_id" => $uid])->one();
      
	   if($Users  !== null)	
         return $Users->users_name;		
	   else
 		return "-";
    }
	
  
	public static function getStateMaster()
    {
        $StateMaster = ArrayHelper::map(State::find()->where(["status" => 1])->orderBy(["state" => SORT_ASC])->all(), 'state', 'state');
        return $StateMaster;
    }
    
	public static function getDistrictMaster()
    {
        $DistrictMaster = ArrayHelper::map(District::find()->where(["status" => 1])->orderBy(["district" => SORT_ASC])->all(), 'district', 'district');
        return $DistrictMaster;
    }

 	
	
  public static function generateControl($form, $model, $template, $ctrlid, $ctrllist, $type = "", $commonfun = "", $depends = "")
    {
    	$storevalue = $dispvalue = $prmpt= "";
		
		if($type == "loc") {            
            if($model->isNewRecord) {
                $storevalue = $model->$ctrlid;
                $dispvalue = $model->$ctrlid;
            } else {
                $storevalue = $model->$ctrlid;              
            }
        }if($type == "state") {            
            if($model->isNewRecord) {
                $storevalue = $model->$ctrlid;
                $dispvalue = $model->$ctrlid;
            } else {
                $storevalue = $model->$ctrlid;
                $SModel = Ti::find()->where(["state" => $model->$ctrlid])->one();				
                $dispvalue = $SModel->state;
            }
            echo Html::hiddenInput('common-method', $commonfun, ['id'=>'common-method']);
            echo Html::hiddenInput('common-method-type', $depends, ['id'=>'common-method-type']);
        } elseif($type == "district") {            
            if($model->isNewRecord) {
               $storevalue = $model->$ctrlid;
               $dispvalue = $model->$ctrlid;
            } else {
                $storevalue = $model->$ctrlid;
                $DModel = Ti::find()->where(["district" => $model->$ctrlid])->one();
                $dispvalue = $DModel->district;
            }
        } else {           
            $storevalue = $model->$ctrlid;
            $dispvalue = $model->$ctrlid;
        }

       // if($model->isNewRecord) {            
            	if($storevalue != "")
            		$model->$ctrlid = $storevalue;
				if($type == "loc") {
					$prmpt='Select State';
                    return $form->field($model, $ctrlid, $template)->dropDownList($ctrllist, ['prompt' => $prmpt]);
                }elseif($type == "artcname") {
					$prmpt='Select ARTC Name';
                    return $form->field($model, $ctrlid, $template)->dropDownList($ctrllist, ['prompt' => $prmpt]);
                }elseif($type == "districtserv") {
					$prmpt='Select District';
                    return $form->field($model, $ctrlid, $template)->dropDownList($ctrllist, ['prompt' => $prmpt]);
                }elseif($type == "staff") {
					$prmpt='Select Staff';
                    return $form->field($model, $ctrlid, $template)->widget(DepDrop::classname(), ['data'=>$ctrllist, 'options'=>['prompt'=>$prmpt], 'type'=>DepDrop::TYPE_SELECT2, 'pluginOptions'=>['depends'=>$depends, 'placeholder'=>$prmpt, 'url'=>Url::to(['/vltransportation/staffdetails']), 'params'=>['common-method', 'common-method-type']]]);
                }				
				else {
					$prmpt='Select';
				    return $form->field($model, $ctrlid, $template)->dropDownList($ctrllist, ['prompt' => $prmpt]);
				}					
      //  }
		/*
		elseif($type == "district") {
					$prmpt='Select District';
                    return $form->field($model, $ctrlid, $template)->widget(DepDrop::classname(), ['data'=>$ctrllist, 'options'=>['prompt'=>$prmpt], 'pluginOptions'=>['depends'=>$depends, 'placeholder'=>$prmpt, 'url'=>Url::to(['/registration/getdistricts'])]]);
                } elseif($type == "districtall") {
					$prmpt='Select District';
                    return $form->field($model, $ctrlid, $template)->widget(DepDrop::classname(), ['data'=>$ctrllist, 'options'=>['prompt'=>$prmpt], 'type'=>DepDrop::TYPE_SELECT2, 'pluginOptions'=>['depends'=>$depends, 'placeholder'=>$prmpt, 'url'=>Url::to(['/registration/districtall']), 'params'=>['common-method', 'common-method-type']]]);
                }	
		else {
            $template['template'] = preg_replace_callback("/{\\w+}/", function ($matches) use ($dispvalue) {
                switch ($matches[0]) {
                    case '{error}':
                          return $dispvalue;
                    default:
                        return $matches[0];
                }
            }, $template['template']);
            return $form->field($model, $ctrlid, $template)->hiddenInput(['value' => $storevalue]);
        }
		
		elseif($type == "service_code") {
					$prmpt='Select Services';
					 return $form->field($model, $ctrlid, $template)->widget(DepDrop::classname(), ['data'=>$ctrllist, 'options'=>['prompt'=>$prmpt], 'type'=>DepDrop::TYPE_SELECT2, 'pluginOptions'=>['depends'=>$depends, 'placeholder'=>$prmpt, 'url'=>Url::to(['/servicecaregiver/getservices']), 'params'=>['common-method', 'common-method-type']]]);				 
                  
                }		
		*/
    }
		
   
    public static function getStateids()
    {
        $StateMaster = ArrayHelper::map(State::find()->where(["status" => 1])->andWhere(["<>","state_id",""])->orderBy(["state" => SORT_ASC])->all(), 'state', 'state');
        return $StateMaster;
    }
	
	
   public static function getDistrictuids()
    {        	
		$DistrictMaster = ArrayHelper::map(District::find()->where(["status" => 1])->andWhere(["<>","district_uid",""])->orderBy(["state" => SORT_ASC,"district" => SORT_ASC])->all(), 'district',  function($model) {
          return $model['district'].' - [ '.$model['state'].' ]';
    });
		 
        return $DistrictMaster;
    }
	
	public static function getDistuids()
   {        	
		$DistrictMaster = ArrayHelper::map(District::find()->where(["status" => 1])->andWhere(["<>","district_uid",""])->orderBy(["state" => SORT_ASC,"district" => SORT_ASC])->all(), 'district', 'district');
		 
        return $DistrictMaster;
   }   
   
	
	 public static function getLocmap()  
   {
	   $sloc=Yii::$app->user->identity->signedin_loc;    
       $sdistrict=Yii::$app->user->identity->district;
		
   }	

  /*
  	public static function getSitedistrict()
    {
	    $sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
		$sdistrict=Yii::$app->user->identity->district;

		if($UserRole <3) 
		  $Master = ArrayHelper::map(District::find()->where(["status" => 1])->andWhere(["<>","district_uid",""])->orderBy(["district" => SORT_ASC])->all(), 'district', 'district');
		else
		  $Master = ArrayHelper::map(District::find()->where(["status" => 1])->andWhere(["<>","district_uid",""])->andWhere(["district"=>$sdistrict])->orderBy(["district" => SORT_ASC])->all(), 'district', 'district'); 	  

        return $Master;
    }
   */		
	
	 public static function getLocdistRep()  
   {
	   $sloc=Yii::$app->user->identity->signedin_loc;    
       $sdistrict=Yii::$app->user->identity->district;
		
   }	
	
	 public static function getStaffnamesRep()
    {   
	    $sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
		$sdistrict=Yii::$app->user->identity->district;
		
		 $Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffcode',function($model) {
          return $model['staffname'].' ('.$model['staffcode'].')';          
        });	 
		/*
			if($UserRole == 1) 
			  $Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffcode',function($model) {
			  return $model['staffname'].' ('.$model['staffcode'].')';          
			});	   
			elseif($UserRole == 2) 
			 $Staffcode = ArrayHelper::map(Staff::find()->where(["district" => $sdistrict])->andWhere(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffcode',function($model) {
			  return $model['staffname'].' ('.$model['staffcode'].')';          
			});	   
			elseif($UserRole == 3) 
			  $Staffcode = ArrayHelper::map(Staff::find()->where(["artccode" => $sloc])->andWhere(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffcode', function($model) {
			  return $model['staffname'].' ('.$model['staffcode'].')';          
			});	
		*/
		
	   return $Staffcode;
    }
	
	 public static function getSitedistrict()
    {
		$sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		
	    $Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;
		
		$sdistrict=Yii::$app->user->identity->district;
		
		if($UserRole == 1) 
          $Master = ArrayHelper::map(District::find()->where(["status" => 1])->andWhere(["<>","district_uid",""])->orderBy(["district" => SORT_ASC])->all(), 'district', 'district');
	    elseif($UserRole == 2)  
		  $Master = ArrayHelper::map(District::find()->where(["status" => 1])->andWhere(["<>","district_uid",""])->andWhere(["district" => $sdistrict])->orderBy(["district" => SORT_ASC])->all(), 'district', 'district');
		elseif($UserRole == 3)   
	     $Master = ArrayHelper::map(District::find()->where(["status" => 1])->andWhere(["<>","district_uid",""])->andWhere(["district" => $sdistrict])->orderBy(["district" => SORT_ASC])->all(), 'district', 'district');
	  
        return $Master;
    }
   
   public static function getArtcs()
   {        	
		$ARTMaster = ArrayHelper::map(Artcentre::find()->where(["status" => 1])->orderBy(["district" => SORT_ASC,"artcname" => SORT_ASC])->all(), 'artccode',  function($model) {  return $model['artcname'].' - [ '.$model['district'].' ]';          
        });	 	
			 
        return $ARTMaster;
   } 
   
    public static function getSiteArtcs()
    {
		$sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
		$sdistrict=Yii::$app->user->identity->district;
		
        if($UserRole == 1) 		
	     $ARTMaster = ArrayHelper::map(Artcentre::find()->where(["status" => 1])->orderBy(["district" => SORT_ASC,"artcname" => SORT_ASC])->all(), 'artccode',  function($model) {  return $model['artcname'].' - [ '.$model['district'].' ]';          
        });	 	
		elseif($UserRole == 2) 
         $ARTMaster = ArrayHelper::map(Artcentre::find()->where(["status" => 1])->andWhere(["district" => $sdistrict])->orderBy(["district" => SORT_ASC,"artcname" => SORT_ASC])->all(), 'artccode',  function($model) {  return $model['artcname'].' - [ '.$model['district'].' ]';          
        });	 	
	    elseif($UserRole == 3)  
	     $ARTMaster = ArrayHelper::map(Artcentre::find()->where(["status" => 1])->andWhere(["artccode" => $sloc])->orderBy(["district" => SORT_ASC,"artcname" => SORT_ASC])->all(), 'artccode',  function($model) {  return $model['artcname'].' - [ '.$model['district'].' ]';          
        });	 	
	  
        return $ARTMaster;
    }	 
	
		
	 public static function getVllcode()
   {        	
		$VllMaster = ArrayHelper::map(Vll::find()->where(["status" => 1])->orderBy(["name_vl_lab_linked" => SORT_ASC])->all(), 'vllcode', function($model) {
		return $model['name_vl_lab_linked'].' ('.$model['vllcode'].')';          
        });	 		
       		
        return $VllMaster;
   } 
   
    public static function getBoxid($artc="", $month = "", $week = "", $year = "")
    {	
  
		$Model = Boxidref::find()->where(["boxid_ref_artccode" => $artc, "boxid_ref_month" => $month, "boxid_ref_week" => $week ,"boxid_ref_year" => $year])->one();      
		$Mnweek= $month."-W".$week."-";		

        if($Model  !== null) {
            if ($Model->boxid_ref_artccode == null){
			 $ref_code =0;
			}
		    else {
			 $ref_code=$Model->boxid_ref_code;
			} 			
			$refid = ($ref_code+1);
		}	
		 else {
		   $refid = 1;
		}
		
		$boxid = $Mnweek.$refid;
		return $boxid;
	}
	
	public static function last_day_of_the_month($date = '')
    {
        $month  = date('m', strtotime($date));
        $year   = date('Y', strtotime($date));
        $result = strtotime("{$year}-{$month}-01");
        $result = strtotime('-1 second', strtotime('+1 month', $result));
        return Converter::toDisplay($result);
    }
	
	
	 public static function getRoleArtcs()
   {        	
		
		$sloc=Yii::$app->user->identity->signedin_loc;
		$sdistrict=Yii::$app->user->identity->district;	
		$suser=Yii::$app->user->identity->users_name;
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
		$Locs = ArrayHelper::map(Userrole::find()->where(["user_id" => $Usermodel->usr_id])->asArray()->all(), 'authorized_loc', 'authorized_loc');
        $loc = "'" . implode($Locs, "','") . "'";
		
	    if($UserRole == 1)        
		  $ARTMaster = ArrayHelper::map(Artcentre::find()->where(["status" => 1])->orderBy(["artcname" => SORT_ASC])->all(), 'artcname', 'artcname');
        elseif($UserRole == 2) 	  
		$ARTMaster = ArrayHelper::map(Artcentre::find()->where("artccode IN ($loc)")->andWhere(["status" => 1])->orderBy(["artcname" => SORT_ASC])->all(), 'artcname', 'artcname');
		elseif($UserRole == 3) 
		  $ARTMaster = ArrayHelper::map(Artcentre::find()->where(["artccode" => $sloc])->andWhere(["status" => 1])->orderBy(["artcname" => SORT_ASC])->all(), 'artcname', 'artcname');			  
	   return $ARTMaster;
	   
    } 
	 
	  public static function getStaffnames()
    {   
	    $sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		$sdistrict=Yii::$app->user->identity->district;
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
		$Locs = ArrayHelper::map(Userrole::find()->where(["user_id" => $Usermodel->usr_id])->asArray()->all(), 'authorized_loc', 'authorized_loc');
        $loc = "'" . implode($Locs, "','") . "'";
		
		$Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffname', 'staffname');
	 /* 
		if($UserRole == 1)        
		  $Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffname', 'staffname');
		elseif($UserRole == 2) 	  
		 $Staffcode = ArrayHelper::map(Staff::find()->where("artccode IN ($loc)")->andWhere(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffname', 'staffname');
		elseif($UserRole == 3) 
		  $Staffcode = ArrayHelper::map(Staff::find()->where(["artccode" => $sloc])->andWhere(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffname', 'staffname');	
      */		  
	   return $Staffcode;
    }
	
	 public static function getStaffcodes()
    {   
	    $sloc=Yii::$app->user->identity->signedin_loc;
		$suser=Yii::$app->user->identity->users_name;
		$sdistrict=Yii::$app->user->identity->district;	
		
		$Usermodel = Users::find()->where(['users_name' => $suser])->one();			   
		$UserRole= $Usermodel->user_role;	
		
		$Locs = ArrayHelper::map(Userrole::find()->where(["user_id" => $Usermodel->usr_id])->asArray()->all(), 'authorized_loc', 'authorized_loc');
        $loc = "'" . implode($Locs, "','") . "'";
		
		$Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->orderBy(["staffcode" => SORT_ASC])->all(), 'staffcode', 'staffcode');
		/*	
			if($UserRole == 1)        
			  $Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->orderBy(["staffcode" => SORT_ASC])->all(), 'staffcode', 'staffcode');
			elseif($UserRole == 2) 	  
			 $Staffcode = ArrayHelper::map(Staff::find()->where("artccode IN ($loc)")->andWhere(["status" => 1])->orderBy(["staffcode" => SORT_ASC])->all(), 'staffcode', 'staffcode');
			elseif($UserRole == 3) 
			  $Staffcode = ArrayHelper::map(Staff::find()->where(["artccode" => $sloc])->andWhere(["status" => 1])->orderBy(["staffcode" => SORT_ASC])->all(), 'staffcode', 'staffcode');
        */		  
		  
	   return $Staffcode;
    }
	
	 public static function getStaffall()
    {   
	   $Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->orderBy(["staffname" => SORT_ASC])->all(), 'staffcode',function($model) {
          return $model['staffname'].' ('.$model['staffcode'].')';   
		 });	
	   return $Staffcode;
    }
	
	 public static function getStaffUser()
    {   
	   $Model = Users::find()->all();
	   $Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->andWhere(["NOT IN", "staffcode", ArrayHelper::getColumn($Model, "users_name")])->orderBy(["staffname" => SORT_ASC])->all(), 'staffcode',function($model) {
          return $model['staffname'].' ('.$model['staffcode'].')';   
		 });	
	   return $Staffcode;
    }
	
	 public static function getStaff()
    {   
	   $Model = Stafflocationmapping::find()->all();
	   $Staffcode = ArrayHelper::map(Staff::find()->where(["status" => 1])->andWhere(["NOT IN", "staffcode", ArrayHelper::getColumn($Model, "staffcode")])->orderBy(["staffname" => SORT_ASC])->all(), 'staffcode',function($model) {
          return $model['staffname'].' ('.$model['staffcode'].')';   
		 });	
	   return $Staffcode;
    }
	
	  public static function getSiteArtcall()
    {
	   $ARTMaster = ArrayHelper::map(Artcentre::find()->where(["status" => 1])->orderBy(["district" => SORT_ASC,"artcname" => SORT_ASC])->all(), 'artccode',  function($model) {  return $model['artcname'].' - [ '.$model['district'].' ]';          
        });	 
	  
        return $ARTMaster;
    }	
	
	   public static function getArtcnames()
   {        	
		$ARTMaster = ArrayHelper::map(Artcentre::find()->where(["status" => 1])->orderBy(["artcname" => SORT_ASC])->all(), 'artcname',  function($model) {  return $model['artcname'].' - [ '.$model['artccode'].' ]';          
        });	 	
			 
        return $ARTMaster;
   } 
		
}
 